# Enum Class Obligation

Object
Enum<Obligation>
Obligation

All Implemented Interfaces:
  `Serializable, Comparable<Obligation>, Constable`

@UML(identifier="MD_ObligationCode", specification=ISO_19115) public enum Obligation extends Enum<Obligation>
Obligation of the element or entity. The enum values declared here duplicate the code list elements declared in the `Obligation` code list from the metadata package.

Since:
  2.0

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum​.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CONDITIONAL`
  Element is required when a specific condition is met.
  `FORBIDDEN`
  The element should always be `null`.
  `MANDATORY`
  Element is always required.
  `OPTIONAL`
  Element is not required.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Obligation`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Obligation[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### CONDITIONAL

    @UML(identifier="conditional", specification=ISO_19115) public static final Obligation CONDITIONAL
    Element is required when a specific condition is met.

  - ### OPTIONAL

    @UML(identifier="optional", specification=ISO_19115) public static final Obligation OPTIONAL
    Element is not required.

  - ### MANDATORY

    @UML(identifier="mandatory", specification=ISO_19115) public static final Obligation MANDATORY
    Element is always required.

  - ### FORBIDDEN

    public static final Obligation FORBIDDEN
    The element should always be `null`. This obligation code is used only when a sub-interface overrides an association and force it to a `null` value. An example is `TemporalDatum​.getAnchorPoint()`.

- ## Method Details

  - ### values

    public static Obligation[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Obligation valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null